/* GCC */
#include <iostream>
#include <stdio.h>
#include <vector>
#include <string>
#include <sstream>
#include <algorithm>

using namespace std;

#define maxN 25

int n=0, minNum;
string letters = "åŪȲ賿";
vector< vector< vector<int> > > ans;
vector< string > names(2*maxN, "");
vector< vector< char > > input(2*maxN, vector<char> (2*maxN, ' '));


int getNum(string s)
{
    for (int i=0; i<2*n; i++)
        if (names[i] == s) return i;

    int curr = 0;
    for (int i=33; i<66; i++)
        if (letters[i] == s[0]) curr += maxN;

    for (int i=0; i<(2*maxN); i++)
        if (names[i] == ""){
            names[i] = s;
            return i;
        }
}

int getLetter(char c)
{
    for (int i=0; i<66; i++)
        if (letters[i] == c) return i;
}

string toNorm(string a)
{
    for (int i=0; i<a.size(); i++)
        a[i] = '!' + getLetter(a[i]);
    return a;
}

void readData(void)
{
    freopen("party.in", "r", stdin);

    string s;
    while (getline(cin, s)){
        while (s[s.size() - 1] == ' ') s.erase(s.size() - 1);

        int i, len=s.size();
        for (i=0; s[i]!=' '; i++);
        int first = getNum(s.substr(0, i));
        char pos = s[++i];
        int second = getNum(s.substr(i+2, len-i-3));
        n = max(n, max(first, second));
        input[first][second] = pos;
        if (pos == '|') input[second][first] = '|';
        if (pos == '>') input[second][first] = '<';
        if (pos == '<') input[second][first] = '>';
    }
    n -= maxN-1;

    for (int i=0; i<names.size(); i++)
        if (names[i] == ""){
            names.erase( names.begin() + i );
            i--;
        }

    ans.push_back(vector< vector<int> > (n, vector<int>(2, -1)));
    vector< pair<string, int> > alphabet(n);
    for (int i=0; i<n; i++) alphabet.push_back( make_pair(toNorm(names[i]), i) );
    sort(alphabet.begin(), alphabet.end());
    minNum = alphabet[0].second;
    ans[0][0][0] = minNum;

    fclose(stdin);
}

char getFromInput(int a, int b)
{
    if (a > n) a += maxN-n;
    if (b > n) b += maxN-n;
    return input[a][b];
}

bool busting(vector< vector<int> > table, vector<bool> used, vector<int> toCheck)
{
    for (int i=0; i<toCheck.size(); i++){
        int curr=toCheck[i], cur_pos;
        for (int z=0; z<n; z++)
            if ((table[i][0] == curr) && (table[i][0] == curr)){
                cur_pos = z;
                break;
            }

        int nest_pos;
        for (int z=0; z<2*n; z++){
            char symb = getFromInput(curr, z);
            if (symb == ' ') continue;

            int next_pos;
            if (symb == '<') next_pos = (cur_pos+1 )%n;
            if (symb == '>') next_pos = (cur_pos+(n-1) )%n;
            if (symb == '|') next_pos = (cur_pos+n/2 )%n;

            if ((table[next_pos][0] != -1) && (table[next_pos][0] != z)) return false;
            if (!used[z]) toCheck.push_back(z);
            table[next_pos][0] = z;
            used[z] = true;
        }

    }

    for (int i=0; i<(n+1); i++){
        if (i == n){
            ans.push_back(table);
            return true;
        }
        if (!used[i]) break;
    }

    for (int z=0; z<n; z++){
        if (used[z]) continue;
        for (int i=0; i<2*n; i++){
            table[i][0] = z;
            used[z] = true;
            toCheck[0] = z;

            busting(table, used, toCheck);

            table[i][0] = -1;
            used[z] = false;
        }
    }

    return false;
}

void fileOut(void)
{
    for (int k=0; k<ans.size(); k++){
        for (int i=0; i<(n-1); i++)
            cout << names[ ans[k][i][0] ] << " (" << names[ ans[k][i][1] ] << "), ";
        cout << names[ ans[k][n-1][0] ] << " (" << names[ ans[k][n-1][1] ] << ").\n";
    }
    fclose(stdout);
}

int main(void)
{
    freopen("party.out", "w", stdout);
    readData();

    vector<bool> used(2*maxN, false);
    used[minNum] = true;

    busting(ans[0], used, vector<int>(1, minNum));
    fileOut();

    return 0;
}






























