/* GCC */
#include <bits/stdc++.h>
using namespace std;

struct rule
{
    int name1;
    int name2;
    char delimiter;
};

char ukr_letters[66] = {-64,-32,-63,-31,-62,-30,-61,-29,-91,-76,-60,-28,-59,-27,-86,-70,-58,-26,-57,-25,-56,-24,-78,-77,-81,-65,-55,-23,-54,-22,-53,-21,-52,-20,-51,
-19,-50,-18,-49,-17,-48,-16,-47,-15,-46,-14,-45,-13,-44,-12,-43,-11,-42,-10,-41,-9,-40,-8,-39,-7,-36,-4,-34,-2,-33,-1};
vector<string> strings;
vector<rule> String_Pool;

bool IsSmall(char c)
{
    for(int i = 1; i < 66; i+= 2)
    {
        if((int)c == ukr_letters[i])
            return true;
    }
    return false;
}

bool IsBig(char c)
{
    for(int i = 0; i < 66; i+= 2)
    {
        if((int)c == ukr_letters[i])
            return true;
    }
    return false;
}

bool IsUkr(char c)
{
    return (IsSmall(c) || IsBig(c));
}

int Code_c(char c)
{
    for(int i = 0; i < 66; i++)
    {
        if(ukr_letters[i] == (int)c)
            return i;
    }
}

int comp_c(char c1, char c2)
{
    if(Code_c(c1) > Code_c(c2))
        return 1;
    if(Code_c(c1) < Code_c(c2))
        return -1;
    return 0;
}

int comp(string s1, string s2)
{
    for(int i = 0; i < min(s1.size(), s2.size()); i++)
    {
        if(comp_c(s1[i], s2[i]) == 1)
            return 1;
        if(comp_c(s1[i], s2[i]) == -1)
            return -1;
    }

    if(s1.size() > s2.size())
        return 1;
    else if(s1.size() < s2.size())
        return -1;
    return 0;

}

int Code(string s)
{
    for(int i = 0; i < strings.size(); i++)
    {
        if(comp(strings[i], s) == 0)
            return i;
    }
    strings.push_back(s);
    return strings.size() - 1;
}

bool IsName(string s)
{
    if(IsBig(s[0]))
        return true;
    else
        return false;
}

void DataRead()
{
    string line;
    while(getline(cin, line))
    {
        int i = 0;
        string s1 = "", s2 = "";
        char delimiter;
        for(; i < line.size() && line[i] != ' '; i++)
            s1+= line[i];

        i++;
        delimiter = line[i];
        i+= 2;

        for(; i < line.size() - 1; i++)
            s2+= line[i];

        rule New;
        New.delimiter = delimiter;
        New.name1 = Code(s1);
        New.name2 = Code(s2);
        String_Pool.push_back(New);
    }
}

bool IsCorrect(vector<int>& name, vector<int>& proff, rule Now)
{
    for(int i = 0; i < name.size(); i++)
    {
        if(name[i] == Now.name2)
        {
            swap(Now.name2, Now.name1);
            if(Now.delimiter == '>')
                Now.delimiter = '<';
            else if(Now.delimiter == '<')
                Now.delimiter = '>';

        }
        if(name[i] == Now.name1)
        {
            int id;
            if(Now.delimiter == '>')
                id = (i + 1) % name.size();
            else if(Now.delimiter == '<')
                id = (i - 1 + name.size()) % name.size();
            else
                id = (i + name.size() / 2) % name.size();

            if(name[id] != Now.name2 && proff[id] != Now.name2)
                return false;
        }
    }

    for(int i = 0; i < proff.size(); i++)
    {
        if(proff[i] == Now.name2)
        {
            swap(Now.name2, Now.name1);
            if(Now.delimiter == '>')
                Now.delimiter = '<';
            else if(Now.delimiter == '<')
                Now.delimiter = '>';

        }
        if(proff[i] == Now.name1)
        {
            int id;
            if(Now.delimiter == '>')
                id = (i + 1) % name.size();
            else if(Now.delimiter == '<')
                id = (i - 1 + name.size()) % name.size();
            else
                id = (i + name.size() / 2) % name.size();

            if(name[id] != Now.name2 && proff[id] != Now.name2)
                return false;
        }
    }
    return true;
}

void DataWrite(vector<pair<vector<int>, vector<int> > > res)
{
    set<pair<vector<int>, vector<int> > > ans;
    for(int i = 0; i < res.size(); i++)
    {
        vector<int> proff, name;
        name = res[i].first;
        proff = res[i].second;

        int j = 0;
        string s = strings[name[0]];
        for(int k = 0; k < name.size(); k++)
        {
            if(comp(s, strings[name[k]]) == 1)
            {
                s = strings[name[k]];
                j = k;
            }
        }

        pair<vector<int>, vector<int> > temp;
        for(int k = 0; k < name.size(); k++)
        {
            int id = (j + k) % name.size();
            temp.first.push_back(name[id]);
            temp.second.push_back(proff[id]);
        }
        ans.insert(temp);
    }

    set<pair<vector<int>, vector<int> > >::iterator it;
    for(it = ans.begin(); it != ans.end(); it++)
    {
        vector<int> proff, name;
        name = (*it).first;
        proff = (*it).second;

        for(int k = 0; k < name.size(); k++)
        {
            cout<< strings[name[k]] << "(" << strings[proff[k]] << ")";
            if(k == name.size() - 1)
                cout<< ".\n";
            else
                cout<< ", ";
        }
    }
}

void DataProcess()
{
    vector<int> name, proff;
    vector<pair<vector<int>, vector<int> > > res;
    for(int i = 0; i < strings.size(); i++)
    {
        if(IsName(strings[i]))
            name.push_back(i);
        else
            proff.push_back(i);
    }

    do
    {
        do
        {
            bool control = true;
            for(int i = 0; i < String_Pool.size(); i++)
            {
                if(!IsCorrect(name, proff, String_Pool[i]))
                {
                    control = false;
                    break;
                }
            }

            if(control)
                res.push_back(make_pair(name, proff));

        }while(next_permutation(proff.begin(), proff.end()));

    }while(next_permutation(name.begin(), name.end()));

    DataWrite(res);
}


int main()
{
    freopen("party.in", "r", stdin);
    freopen("party.out", "w", stdout);

    /*char c;
    while(cin>> c)
    {
        cout<< (int)c << ", ";
    }*/

    DataRead();
    DataProcess();

    return 0;
}
