#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

const int maxN = 25;
vector<vector<vector<int> > > ans;
vector<vector<char> > input(2*maxN, vector<char> (2*maxN, ' '));
vector<string> names(2*maxN, "");
int n = 0, minNum;
string letters = "åŪȲ賿";

int getLetterPos(char c){
    for (int i = 0; i < 66; i++){
        if (c == letters[i]){
            return i;
        }
    }
    return -1;
}

string toNorm(string a){
    for (size_t i = 0; i < a.size(); i++){
        a[i] = '!' + getLetterPos(a[i]);
    }
    return a;
}

int getNum(string s){
    for (int i = 0; i < 2*maxN; i++){
        if (s == names[i]){
            return i;
        }
    }
    int curr = 0;
    for (int i = 33; i < 66; i++){
        if (letters[i] == s[0]){
            curr += maxN;
        }
    }
    for (int i = curr; i < curr+maxN; i++){
        if (names[i] == ""){
            names[i] = s;
            return i;
        }
    }
    return -1;
}

void readData(){
    string s;
    while(getline(cin, s)){
        while (s[s.size()-1] == ' '){
            s.erase(s.end()-1);
        }

        int i = 0, l = s.size();
        while (s[i] != ' ') i++;
        int first = getNum(s.substr(0, i));
        char pos = s[++i];
        int second = getNum(s.substr(i+2, l-i-3));
        n = max(n, max(first, second));
        input[first][second] = pos;
        if (pos == '|') input[second][first] = '|';
        if (pos == '<') input[second][first] = '>';
        if (pos == '>') input[second][first] = '<';
    }
    n -= maxN-1;

    for (unsigned int i = 0; i < names.size(); i++){
        if (names[i] == ""){
            names.erase(names.begin()+i);
            i--;
        }
    }

    ans.push_back(vector<vector<int> > (n, vector<int>(2, -1)));
    vector<pair<string, int> > alphabet(n);
    for(int i = 0; i < n; i++) alphabet[i] = make_pair(toNorm(names[i]), i);
    sort(alphabet.begin(), alphabet.end());
    minNum = alphabet[0].second;
    ans[0][0][0] = minNum;
}

char getFromInput(int a, int b){
    if (a >= n) a += maxN - n;
    if (b >= n) b += maxN - n;
    return input[a][b];
}

void busting(vector<vector<int> > table, vector<bool> used, vector<int> toCheck){
    for (unsigned int i = 0; i < toCheck.size(); i++){
        int curr = toCheck[i], currPos;
        for (int z = 0; z < n; z++){
            if(table[z][0] == curr || table[z][1] == curr){
                currPos = z;
                break;
            }
        }

        for (int z = 0; z < 2*n; z++){
            char symb = getFromInput(curr, z);
            if (symb == ' ') continue;

            int nextPos;
            if (symb == '|') nextPos = (currPos + n/2)%n;
            if (symb == '<') nextPos = (currPos + 1)%n;
            if (symb == '>') nextPos = (currPos + n - 1)%n;

            int k = z/n;
            if (table[nextPos][k] != -1 && table[nextPos][k] != z){
                return;
            }
            if (!used[z]) toCheck.push_back(z);
            used[z] = true;
            table[nextPos][k] = z;
        }
    }

    for (int i = 0; i <= 2*n; i++){
        if (i == 2*n){
            ans.push_back(table);
        }
        if (!used[i]) break;
    }

    toCheck = vector<int>(1);
    for (int z = 0; z < 2*n; z++){
        if (used[z]) continue;
        for (int i = 0; i < n; i++){
            int k = z/n;
            if (table[i][k] != -1) continue;
            toCheck[0] = z;
            table[i][k] = z;
            used[z] = true;
            busting(table, used, toCheck);
            used[z] = false;
            table[i][k] = -1;
        }
        break;
    }
}

void fileOut(){
    for (unsigned int k = 1; k < ans.size(); k++){
        for (unsigned int i = 0; i < ans[k].size()-1; i++){
            cout << names[ans[k][i][0]] << " (" << names[ans[k][i][1]] << "), ";
        }
        cout << names[ans[k][ans[k].size()-1][0]] << " (" << names[ans[k][ans[k].size()-1][1]] << ")." << endl;
    }
}

int main(){
    freopen("party.in", "r", stdin);
    freopen("party.out", "w", stdout);
    readData();
    fclose(stdin);

    vector<bool> used(2*n, false);
    used[minNum] = true;

    busting(ans[0], used, vector<int>(1, minNum));

    fileOut();
    fclose(stdout);
    return 0;
}
















